<?php
/**
 * Tbay Variable product add to cart
 *
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

wp_enqueue_script( 'wc-single-product' );

global $product,$product_load_more;

$variations_class =	'';

if( isset($product_load_more['class']) ) {
	$variations_class = $product_load_more['class'];
}

$attribute_keys = array_keys( $attributes );

remove_action( 'woocommerce_before_add_to_cart_form', 'puca_action_woocommerce_before_add_to_cart_button', 10, 0 ); 
remove_action( 'woocommerce_before_add_to_cart_form', 'puca_mobile_add_before_add_to_cart_form', 20, 1 ); 
do_action( 'woocommerce_before_add_to_cart_form' ); 
add_action( 'woocommerce_before_add_to_cart_form', 'puca_action_woocommerce_before_add_to_cart_button', 10, 0 ); 
add_action( 'woocommerce_before_add_to_cart_form', 'puca_mobile_add_before_add_to_cart_form', 20, 1 ); 
?>

<form class="variations_form cart tbay-variations <?php echo esc_attr($variations_class); ?>" method="post" enctype='multipart/form-data' data-product_id="<?php echo absint( $product->get_id() ); ?>" data-product_variations="<?php echo htmlspecialchars( wp_json_encode( $available_variations ) ) ?>">
	<?php 
		remove_action( 'woocommerce_before_variations_form', 'puca_mobile_add_before_variations_form', 10, 1 ); 
		do_action( 'woocommerce_before_variations_form' ); 
		add_action( 'woocommerce_before_variations_form', 'puca_mobile_add_before_variations_form', 10, 1 ); 
	?>

	<?php if ( empty( $available_variations ) && false !== $available_variations ) : ?>
		<p class="stock out-of-stock"><?php esc_html_e( 'This product is currently out of stock and unavailable.', 'puca' ); ?></p>
	<?php else : ?>
		<table class="variations">
			<tbody>
				<?php foreach ( $attributes as $attribute_name => $options ) : ?>
					<tr>
						<td class="value">
							<?php
								$_id = puca_tbay_random_key();
								$_id = $attribute_name.'-'.$_id;
								$selected = isset( $_REQUEST[ 'attribute_' . sanitize_title( $attribute_name ) ] ) ? wc_clean( stripslashes( urldecode( $_REQUEST[ 'attribute_' . sanitize_title( $attribute_name ) ] ) ) ) : $product->get_variation_default_attribute( $attribute_name );
 								wc_dropdown_variation_attribute_options( array( 'options' => $options, 'attribute' => $attribute_name, 'product' => $product, 'selected' => $selected, 'name' => '', 'id' => $_id ) );
								echo end( $attribute_keys ) === $attribute_name ? apply_filters( 'woocommerce_reset_variations_link', '<a class="reset_variations" href="#">' . esc_html__( 'Clear', 'puca' ) . '</a>' ) : '';
							?>
						</td>
					</tr>
				<?php endforeach;?>
			</tbody>
		</table>


	<?php endif; ?>

	<?php do_action( 'woocommerce_after_variations_form' ); ?>
</form>  
<?php
remove_action( 'woocommerce_after_add_to_cart_form', 'puca_mobile_add_btn_after_add_to_cart_form', 10, 1 ); 
do_action( 'woocommerce_after_add_to_cart_form' );
add_action( 'woocommerce_after_add_to_cart_form', 'puca_mobile_add_btn_after_add_to_cart_form', 10, 1 ); 
